## odil 0.9.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project("odil")
set(odil_MAJOR_VERSION 0)
set(odil_MINOR_VERSION 9)
set(odil_PATCH_VERSION 2)
set(odil_VERSION
    ${odil_MAJOR_VERSION}.${odil_MINOR_VERSION}.${odil_PATCH_VERSION})

option(BUILD_SHARED_LIBS "Build Odil with shared libraries." ON)
option(BUILD_EXAMPLES "Build the examples directory." ON)
option(BUILD_PYTHON_WRAPPERS "Build the Python Wrappers." ON)
option(BUILD_JAVASCRIPT_WRAPPERS "Build the Javascript Wrappers." OFF)

option(WITH_DCMTK "Build the DCMTK converter" ON)
option(
    USE_BUILTIN_DCMTK_GETSCU
    "Compile a locally packaged version of getscu for old DCMTK versions" ON)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}" ${CMAKE_MODULE_PATH})
include(CTest)
include(cmake/functions.cmake)

# Add the C++0x or C++11 flag
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-std=c++11 COMPILER_SUPPORTS_CXX11)
CHECK_CXX_COMPILER_FLAG(-std=c++0x COMPILER_SUPPORTS_CXX0X)
if(COMPILER_SUPPORTS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
endif()

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

if(WIN32)
    # We have to set _WIN32_WINNT for Asio
    if(${CMAKE_SYSTEM_VERSION} EQUAL 10) # Windows 10
        add_definitions(-D _WIN32_WINNT=0x0A00)
    elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.3) # Windows 8.1
        add_definitions(-D _WIN32_WINNT=0x0603)
    elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.2) # Windows 8
        add_definitions(-D _WIN32_WINNT=0x0602)
    elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.1) # Windows 7
        add_definitions(-D _WIN32_WINNT=0x0601)
    elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.0) # Windows Vista
        add_definitions(-D _WIN32_WINNT=0x0600)
    else() # Windows XP (5.1)
        add_definitions(-D _WIN32_WINNT=0x0501)
    endif()
endif()

add_subdirectory("src")

if(BUILD_EXAMPLES)
    add_subdirectory("examples")
endif()

if(BUILD_TESTING)
    add_subdirectory("tests")
endif()

if(BUILD_PYTHON_WRAPPERS)
    add_subdirectory("wrappers/python")
    add_subdirectory("applications")
endif()

if(BUILD_JAVASCRIPT_WRAPPERS)
    add_subdirectory("wrappers/js")
endif()

file(GLOB_RECURSE ci_resources .ci/*)
add_custom_target(
    CIIntegration ${CMAKE_COMMAND} -E echo "CI Integration"
    SOURCES appveyor.yml .travis.yml ${ci_resources})
set_target_properties(CIIntegration PROPERTIES FOLDER "Utils")

file(GLOB_RECURSE documentation documentation/*)
add_custom_target(
    Documentation ${CMAKE_COMMAND} -E echo "Documentation"
    SOURCES LICENSE.txt README.md ${documentation})
set_target_properties(Documentation PROPERTIES FOLDER "Utils")

file(GLOB_RECURSE registry_templates registry*.tmpl)
add_custom_target(
    Registry ${CMAKE_COMMAND} -E echo "Registry"
    SOURCES generate_registry ${registry_templates})
set_target_properties(Registry PROPERTIES FOLDER "Utils")

=== src/CMakeLists.txt ===
find_package(Boost REQUIRED COMPONENTS date_time filesystem system)
find_package(ICU REQUIRED)
find_package(JsonCpp REQUIRED)
find_package(Log4Cpp REQUIRED)
if(WITH_DCMTK)
    find_package(DCMTK REQUIRED)
endif()

file(GLOB_RECURSE Header_Files "*.h")
file(GLOB_RECURSE Source_Files "*.cpp")
file(GLOB_RECURSE templates "*.txx")
list(SORT Header_Files)
list(SORT Source_Files)
list(SORT templates)

if(NOT WITH_DCMTK)
    set(pattern "${CMAKE_CURRENT_SOURCE_DIR}/odil/dcmtk/[^;]+[;$]")
    string(REGEX REPLACE ${pattern} "" Header_Files "${Header_Files}")
    string(REGEX REPLACE ${pattern} "" Source_Files "${Source_Files}")
    string(REGEX REPLACE ${pattern} "" templates "${templates}")
endif()

# Regroup files by folder
GroupFiles(Header_Files)
GroupFiles(Source_Files)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR} ${Boost_INCLUDE_DIRS} ${DCMTK_INCLUDE_DIRS}
${ICU_INCLUDE_DIRS} ${Log4Cpp_INCLUDE_DIRS} ${JsonCpp_INCLUDE_DIRS})

add_definitions(
    ${DCMTK_DEFINITIONS}
    -D BOOST_ASIO_SEPARATE_COMPILATION
    -D ODIL_MAJOR_VERSION=${odil_MAJOR_VERSION}
)
if(BUILD_SHARED_LIBS)
    add_definitions(-D BOOST_ALL_DYN_LINK)
endif()

link_directories(${Boost_LIBRARY_DIRS} ${DCMTK_LIBRARY_DIRS})

add_library(libodil ${Source_Files} ${Header_Files} ${templates})
set_target_properties(libodil PROPERTIES OUTPUT_NAME odil)

target_link_libraries(libodil
    ${Boost_LIBRARIES} ${DCMTK_LIBRARIES} ${ICU_LIBRARIES} ${JsonCpp_LIBRARIES}
    ${Log4Cpp_LIBRARIES})

if(WIN32)
    add_definitions(-DBUILDING_ODIL)
    target_link_libraries(libodil netapi32)
endif()

set_target_properties(libodil PROPERTIES
    VERSION ${odil_VERSION}
    SOVERSION ${odil_MAJOR_VERSION})
if(APPLE)
    set_target_properties(
        libodil PROPERTIES INSTALL_NAME_DIR ${CMAKE_INSTALL_PREFIX}/lib)
endif()

install(
    DIRECTORY odil/ DESTINATION include/odil
    FILES_MATCHING PATTERN "*.h" PATTERN "*.txx")
install(
    TARGETS libodil
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION bin)

=== tests/CMakeLists.txt ===
find_package(Boost COMPONENTS unit_test_framework REQUIRED)
find_package(DCMTK REQUIRED)
find_package(JsonCpp REQUIRED)

add_subdirectory(tools)

file(GLOB headers *.h)
file(GLOB_RECURSE tests code/*.cpp)
if(NOT WITH_DCMTK)
    list(
        REMOVE_ITEM tests
        ${CMAKE_CURRENT_SOURCE_DIR}/code/conversion.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/code/DcmtkException.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/code/ElementAccessor.cpp)
    set(
        extra_files
        ${CMAKE_SOURCE_DIR}/src/odil/dcmtk/conversion.cpp
        ${CMAKE_SOURCE_DIR}/src/odil/dcmtk/ElementAccessor.cpp
        ${CMAKE_SOURCE_DIR}/src/odil/dcmtk/ElementTraits.cpp
        ${CMAKE_SOURCE_DIR}/src/odil/dcmtk/Exception.cpp)
endif()

include_directories(
    ${CMAKE_SOURCE_DIR}/src ${Boost_INCLUDE_DIRS} ${DCMTK_INCLUDE_DIRS}
    ${JsonCpp_INCLUDE_DIRS})

add_definitions(
    ${DCMTK_DEFINITIONS}
    -D ODIL_MAJOR_VERSION=${odil_MAJOR_VERSION}
)
if(BUILD_SHARED_LIBS)
    add_definitions(-D BOOST_ALL_DYN_LINK)
endif()

link_directories(${Boost_LIBRARY_DIRS} ${DCMTK_LIBRARY_DIRS})


foreach(test_file ${tests})
    get_filename_component(unit ${test_file} NAME_WE)
    get_filename_component(module ${test_file} PATH)
    get_filename_component(module ${module} NAME)
    if(NOT "${module}" STREQUAL "code")
        set(test "${module}_${unit}")
    else()
        set(test "${unit}")
    endif()

    add_executable(test_${test} ${test_file} ${headers} ${extra_files})
    target_link_libraries(
        test_${test} libodil ${Boost_LIBRARIES} ${DCMTK_LIBRARIES})
    set_target_properties(test_${test} PROPERTIES OUTPUT_NAME ${test} FOLDER "Tests")

    file(READ ${test_file} content)

    set(pattern "BOOST_(AUTO|FIXTURE)_TEST_CASE\\(([^),]+)")

    string(REGEX MATCHALL ${pattern} cases ${content})

    foreach(case ${cases})
        string(REGEX REPLACE ${pattern} "\\2" case ${case})
        if(NOT ${case} MATCHES "##")
            add_test("${test}_${case}" "${test}" "--run_test=${case}")
        endif()
    endforeach()

    set(pattern "ElementTest\\([\n ]+([A-Z]+)")

    string(REGEX MATCHALL ${pattern} matches ${content})

    foreach(match ${matches})
        string(REGEX REPLACE ${pattern} "\\1" vr ${match})

        set(case "${vr}FromOdil")
        add_test("${test}_${case}" "${test}" "--run_test=${case}")

        set(case "${vr}ToOdil")
        add_test("${test}_${case}" "${test}" "--run_test=${case}")
    endforeach()

endforeach()

file(GLOB_RECURSE python_tests *.py)

add_custom_target(Runner ${CMAKE_COMMAND} -E echo "Test runner" SOURCES run)
add_custom_target(
    PythonTests ${CMAKE_COMMAND} -E echo "Python tests" SOURCES ${python_tests})

=== wrappers/python/CMakeLists.txt ===
find_package(Boost REQUIRED COMPONENTS python)
find_package(JsonCpp REQUIRED)
find_package(PythonInterp 2.7 REQUIRED)
find_package(PythonLibs 2.7 REQUIRED)

if(NOT "${PYTHONLIBS_VERSION_STRING}" STREQUAL "${PYTHON_VERSION_STRING}")
    message(
        WARNING
        "Python version mismatch:  libraries are \"${PYTHONLIBS_VERSION_STRING}\", interpreter is \"${PYTHON_VERSION_STRING}\"")
endif()

if(BUILD_SHARED_LIBS)
    add_definitions(-D BOOST_ALL_DYN_LINK)
endif()

include_directories(
    ${CMAKE_SOURCE_DIR}/src ${Boost_INCLUDE_DIRS}
    ${JsonCpp_INCLUDE_DIRS} ${PYTHON_INCLUDE_DIRS})
link_directories(${Boost_LIBRARY_DIRS})

file(GLOB_RECURSE Header_Files "*.h")
file(GLOB_RECURSE Source_Files "*.cpp")
set(Python_Files "__init__.py")

list(SORT Header_Files)
list(SORT Source_Files)
list(SORT Python_Files)

python_add_module(pyodil SHARED ${Source_Files} ${Header_Files})
set_target_properties(pyodil PROPERTIES OUTPUT_NAME _odil FOLDER "Wrappers")
if(APPLE)
    set_target_properties(pyodil PROPERTIES SUFFIX ".so")
endif()

target_link_libraries(
    pyodil ${Boost_LIBRARIES} ${JsonCpp_LIBRARIES} libodil ${PYTHON_LIBRARIES})

add_custom_target(
    pyodil-pure ${CMAKE_COMMAND} -E echo "Pure-python files"
    SOURCES ${Python_Files})
set_target_properties(pyodil-pure PROPERTIES FOLDER "Wrappers")

execute_process(
    COMMAND ${PYTHON_EXECUTABLE}
      -c "from distutils.sysconfig import *; print(get_python_lib(True, prefix=''))"
    OUTPUT_VARIABLE PYTHON_SITE_PACKAGES
    OUTPUT_STRIP_TRAILING_WHITESPACE)

install(DIRECTORY DESTINATION "${PYTHON_SITE_PACKAGES}")
install(TARGETS pyodil DESTINATION "${PYTHON_SITE_PACKAGES}/odil")
install(FILES ${Python_Files} DESTINATION "${PYTHON_SITE_PACKAGES}/odil")

=== debian/changelog ===
odil (0.9.2-1) unstable; urgency=medium

  * New upstream release
  * Update standards version

 -- Julien Lamy <lamy@unistra.fr>  Thu, 03 May 2018 13:47:41 +0000

odil (0.9.1-1) unstable; urgency=medium

  [ Julien Lamy ]
  * New upstream release
  * Use Python 3 in  CLI application
  * Update standards version
  * Update the VCS URLS in d/control to point to salsa.debian.org

  [ Andreas Tille ]
  * by using versioned Build-Depends: d-shlibs (>= 0.81) manual overrides in
    d/rules can be dropped

 -- Julien Lamy <lamy@unistra.fr>  Thu, 01 Mar 2018 17:06:03 +0000

=== debian/control ===
Source: odil
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Julien Lamy <lamy@unistra.fr>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               d-shlibs (>= 0.81),
               dh-python,
               cmake,
               g++ (>= 4:7),
               pkg-config,
               libjsoncpp-dev,
               libdcmtk-dev | libdcmtk2-dev,
               libicu-dev (>= 4.8.1.1),
               zlib1g-dev,
               uuid-dev,
               libboost-dev,
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-python-dev,
               liblog4cpp5-dev,
               libboost-test-dev (>= 1.46.1),
               chrpath,
               dcmtk (>= 3.6.0),
               python-dev,
               python3-dev,
               python-nose,
               python3-nose
Build-Depends-Indep: doxygen, graphviz
Standards-Version: 4.1.4
Vcs-Browser: https://salsa.debian.org/med-team/odil
Vcs-Git: https://salsa.debian.org/med-team/odil.git
Homepage: https://github.com/lamyj/odil
X-Python-Version: >= 2.7
X-Python3-Version: >= 3.4

Package: libodil0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Provides: libdcmtkpp0
Conflicts: libdcmtkpp0
Replaces: libdcmtkpp0
Multi-Arch: same
Description: C++11 library for the DICOM standard
 Odil leverages C++ constructs to provide a user-friendly API of the 
 different parts of the DICOM standard. Included in Odil are exception-based
 error handling, generic access to datasets elements, standard JSON and XML 
 representation of datasets, and generic implementation of messages, clients
 and servers for the various DICOM protocols.
 .
 Odil also provides conversion to and from DCMTK data structures.
 .
 This package contains the shared library.

Package: libodil-dev
Architecture: any
Section: libdevel
Depends: libodil0 (= ${binary:Version}),
         ${devlibs:Depends},
         ${misc:Depends}
Provides: libodil0-dev, libdcmtkpp-dev
Conflicts: libodil0-dev, libdcmtkpp-dev
Replaces: libodil0-dev, libdcmtkpp-dev
Multi-Arch: same
Description: C++11 library for the DICOM standard (development files)
 Odil leverages C++ constructs to provide a user-friendly API of the 
 different parts of the DICOM standard. Included in Odil are exception-based
 error handling, generic access to datasets elements, standard JSON and XML 
 representation of datasets, and generic implementation of messages, clients
 and servers for the various DICOM protocols.
 .
 This package contains the development files.

Package: libodil-doc
Architecture: all
Section: doc
Depends: libjs-jquery,
         ${misc:Depends}
Provides: libodil0-doc, libdcmtkpp0-doc
Conflicts: libodil0-doc, libdcmtkpp0-doc
Replaces: libodil0-doc, libdcmtkpp0-doc
Multi-Arch: foreign
Description: C++11 library for the DICOM standard (documentation)
 Odil leverages C++ constructs to provide a user-friendly API of the 
 different parts of the DICOM standard. Included in Odil are exception-based
 error handling, generic access to datasets elements, standard JSON and XML 
 representation of datasets, and generic implementation of messages, clients
 and servers for the various DICOM protocols.
 .
 This package contains the documentation files.

Package: python-odil
Architecture: any
Section: python
Depends: libodil0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${python:Depends},
         ${misc:Depends}
Multi-Arch: foreign
Description: C++11 library for the DICOM standard (Python wrappers)
 Odil leverages C++ constructs to provide a user-friendly API of the 
 different parts of the DICOM standard. Included in Odil are exception-based
 error handling, generic access to datasets elements, standard JSON and XML 
 representation of datasets, and generic implementation of messages, clients
 and servers for the various DICOM protocols.
 .
 This package contains the Python wrappers.

Package: python3-odil
Architecture: any
Section: python
Depends: libodil0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends}
Multi-Arch: foreign
Description: C++11 library for the DICOM standard (Python 3 wrappers)
 Odil leverages C++ constructs to provide a user-friendly API of the 
 different parts of the DICOM standard. Included in Odil are exception-based
 error handling, generic access to datasets elements, standard JSON and XML 
 representation of datasets, and generic implementation of messages, clients
 and servers for the various DICOM protocols.
 .
 This package contains the Python 3 wrappers.

Package: odil
Architecture: all
Depends: python3-odil, ${python3:Depends}, ${misc:Depends}
Description: C++11 library for the DICOM standard (application)
 Odil leverages C++ constructs to provide a user-friendly API of the 
 different parts of the DICOM standard. Included in Odil are exception-based
 error handling, generic access to datasets elements, standard JSON and XML 
 representation of datasets, and generic implementation of messages, clients
 and servers for the various DICOM protocols.
 .
 This package contains the command-line application.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CXXFLAGS_MAINT_APPEND  = -std=c++0x
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Find all Python versions
PYTHON2=$(shell pyversions -vrd)
PYTHON3=$(shell py3versions -vrd)
ALLPY=$(PYTHON2) $(PYTHON3)

# Required to get the full path to the boost.python library
TRIPLET=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --builddirectory=build --with python2,python3

# Base build: no wrappers
override_dh_auto_configure-arch:
	dh_auto_configure -- \
	  -DBUILD_EXAMPLES=OFF \
	  -DBUILD_PYTHON_WRAPPERS=OFF -DBUILD_JAVASCRIPT_WRAPPERS=OFF

override_dh_auto_build-nopy:
	dh_auto_build
	mv build build-nopy

# Reconfigure base build for specific Python version and build wrappers
# WARNING: Python2 and Python3 MUST be built sequentially since they use the 
# same build directory
override_dh_auto_build-py: override_dh_auto_build-nopy
	for Python in $(ALLPY); do \
	  PythonNoDot=$$(echo $${Python} | sed 's|\.||'); \
	  cp -a build-nopy build; \
	  dh_auto_configure -- \
	    -DBUILD_EXAMPLES=OFF \
	    -DBUILD_PYTHON_WRAPPERS=ON -DBUILD_JAVASCRIPT_WRAPPERS=OFF \
	    -DPython_ADDITIONAL_VERSIONS=$${Python} \
	    -DPYTHON_EXECUTABLE=/usr/bin/python$${Python} \
	    -DBoost_PYTHON_LIBRARY_DEBUG=/usr/lib/$(TRIPLET)/libboost_python-py$${PythonNoDot}.so \
	    -DBoost_PYTHON_LIBRARY_RELEASE=/usr/lib/$(TRIPLET)/libboost_python-py$${PythonNoDot}.so; \
	  dh_auto_build; \
	  mv build build-py$${Python}; \
	done

override_dh_auto_build-arch: override_dh_auto_build-nopy override_dh_auto_build-py

override_dh_auto_build-indep:
	dh_auto_configure --builddirectory=build-indep -- \
	  -DBUILD_EXAMPLES=OFF \
	  -DBUILD_PYTHON_WRAPPERS=ON -DBUILD_JAVASCRIPT_WRAPPERS=OFF \
	  -DPYTHON_EXECUTABLE=/usr/bin/python$(PYTHON3)
	mkdir -p documentation/_build
	cd documentation && doxygen
	find documentation/_build -name "*.md5" -delete

override_dh_makeshlibs-arch:
	dh_makeshlibs -V'libodil0 (>= 0.9.2-1)'

# Run C++ tests only on base build
override_dh_auto_test-arch-nopy:
	ln -s build-nopy build
	cd build && ../tests/run --no-network -e ".*"
	rm build

# Run Python tests only on python build
# WARNING: Python2 and Python3 MUST be tested sequentially since they use the 
# same build directory
override_dh_auto_test-arch-py: override_dh_auto_test-arch-nopy
	for Python in $(ALLPY); do \
	  ln -s build-py$${Python} build; \
	  ln -sr ./build/wrappers/python ./build/odil; \
	  ln -sr ./wrappers/python/*.py ./build/odil; \
	  cd build && \
	    ../tests/run --no-network \
	      --nose nosetests$$(dpkg --compare-versions $${Python} ge 3 && echo "3") \
	      -E ".*"; \
	  cd ..; \
	  rm ./build/odil/*py; \
	  rm ./build/odil; \
	  rm build; \
	done

override_dh_auto_test-arch: override_dh_auto_test-arch-nopy override_dh_auto_test-arch-py

override_dh_auto_install-arch-nopy:
	ln -s build-nopy build
	$(MAKE) -C build/src install DESTDIR=$(CURDIR)/debian/tmp
	rm build

# WARNING: Python2 and Python3 MUST be installed sequentially since they use the 
# same build directory
override_dh_auto_install-arch-py: override_dh_auto_install-arch-nopy
	for Python in $(ALLPY); do \
	  ln -s build-py$${Python} build; \
	  $(MAKE) -C build/wrappers/python install DESTDIR=$(CURDIR)/debian/tmp; \
	  rm build; \
	done

override_dh_auto_install-arch: override_dh_auto_install-arch-nopy override_dh_auto_install-arch-py

override_dh_auto_install-indep:
	ln -s build-indep build
	$(MAKE) -C build/applications install DESTDIR=$(CURDIR)/debian/tmp
	rm build

override_dh_install-arch:
	dh_install
	d-shlibmove \
		--devunversioned \
		--commit --multiarch --exclude-a --exclude-la \
		--movedev debian/tmp/usr/include/* usr/include \
		debian/tmp/usr/lib/*.so


override_dh_clean:
	dh_clean
	find tests -name "*pyc" -delete
	rm -rf build-nopy $(ALLPY:%=build-py%) build-indep documentation/_build

# These steps are not needed for arch-independent packages
override_dh_auto_configure-indep:
override_dh_auto_test-indep:

## odil 0.10.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,8 +2,8 @@
 
 project("odil")
 set(odil_MAJOR_VERSION 0)
-set(odil_MINOR_VERSION 9)
-set(odil_PATCH_VERSION 2)
+set(odil_MINOR_VERSION 10)
+set(odil_PATCH_VERSION 0)
 set(odil_VERSION
     ${odil_MAJOR_VERSION}.${odil_MINOR_VERSION}.${odil_PATCH_VERSION})

=== applications/CMakeLists.txt ===
file(GLOB_RECURSE module_files *.py)
set(python_files ${module_files} odil)
add_custom_target(
    PythonFiles ${CMAKE_COMMAND} -E echo "Python files" SOURCES ${python_files})
set_target_properties(PythonFiles PROPERTIES FOLDER "Examples")

if(BUILD_PYTHON_WRAPPERS)
    execute_process(
        COMMAND ${PYTHON_EXECUTABLE}
          -c "from distutils.sysconfig import *; print(get_python_lib(True, prefix=''))"
        OUTPUT_VARIABLE PYTHON_SITE_PACKAGES
        OUTPUT_STRIP_TRAILING_WHITESPACE)

    install(DIRECTORY DESTINATION "${PYTHON_SITE_PACKAGES}")
    install(FILES ${module_files} DESTINATION "${PYTHON_SITE_PACKAGES}/odil/cli")
    configure_file("odil" "${CMAKE_CURRENT_BINARY_DIR}/odil")
    install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/odil" DESTINATION bin)
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,6 @@
-find_package(Boost REQUIRED COMPONENTS date_time filesystem system)
+find_package(Boost REQUIRED COMPONENTS date_time filesystem log system)
 find_package(ICU REQUIRED)
 find_package(JsonCpp REQUIRED)
-find_package(Log4Cpp REQUIRED)
 if(WITH_DCMTK)
     find_package(DCMTK REQUIRED)
 endif()
@@ -26,7 +25,7 @@
 
 include_directories(
     ${CMAKE_CURRENT_SOURCE_DIR} ${Boost_INCLUDE_DIRS} ${DCMTK_INCLUDE_DIRS}
-${ICU_INCLUDE_DIRS} ${Log4Cpp_INCLUDE_DIRS} ${JsonCpp_INCLUDE_DIRS})
+    ${ICU_INCLUDE_DIRS} ${JsonCpp_INCLUDE_DIRS})
 
 add_definitions(
     ${DCMTK_DEFINITIONS}
@@ -43,12 +42,17 @@
 set_target_properties(libodil PROPERTIES OUTPUT_NAME odil)
 
 target_link_libraries(libodil
-    ${Boost_LIBRARIES} ${DCMTK_LIBRARIES} ${ICU_LIBRARIES} ${JsonCpp_LIBRARIES}
-    ${Log4Cpp_LIBRARIES})
+    ${Boost_LIBRARIES} ${DCMTK_LIBRARIES} ${ICU_LIBRARIES} ${JsonCpp_LIBRARIES})
 
 if(WIN32)
     add_definitions(-DBUILDING_ODIL)
     target_link_libraries(libodil netapi32)
+    if(${VCPKG_TOOLCHAIN})
+		# WARNING Need to link with bcrypt explicitely, 
+		# cf. https://github.com/boostorg/uuid/issues/68#issuecomment-430173245
+        # Not sure why iphlpapi is not linked.
+		target_link_libraries(libodil bcrypt iphlpapi)
+	endif()
 endif()
 
 set_target_properties(libodil PROPERTIES

=== wrappers/python/CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,5 @@
-find_package(Boost REQUIRED COMPONENTS python)
 find_package(JsonCpp REQUIRED)
-find_package(PythonInterp 2.7 REQUIRED)
-find_package(PythonLibs 2.7 REQUIRED)
-
-if(NOT "${PYTHONLIBS_VERSION_STRING}" STREQUAL "${PYTHON_VERSION_STRING}")
-    message(
-        WARNING
-        "Python version mismatch:  libraries are \"${PYTHONLIBS_VERSION_STRING}\", interpreter is \"${PYTHON_VERSION_STRING}\"")
-endif()
+find_package(pybind11 REQUIRED)
 
 if(BUILD_SHARED_LIBS)
     add_definitions(-D BOOST_ALL_DYN_LINK)
@@ -26,14 +18,14 @@
 list(SORT Source_Files)
 list(SORT Python_Files)
 
-python_add_module(pyodil SHARED ${Source_Files} ${Header_Files})
+pybind11_add_module(pyodil SHARED ${Source_Files} ${Header_Files})
+
 set_target_properties(pyodil PROPERTIES OUTPUT_NAME _odil FOLDER "Wrappers")
 if(APPLE)
     set_target_properties(pyodil PROPERTIES SUFFIX ".so")
 endif()
 
-target_link_libraries(
-    pyodil ${Boost_LIBRARIES} ${JsonCpp_LIBRARIES} libodil ${PYTHON_LIBRARIES})
+target_link_libraries(pyodil ${JsonCpp_LIBRARIES} libodil)
 
 add_custom_target(
     pyodil-pure ${CMAKE_COMMAND} -E echo "Pure-python files"

=== debian/changelog ===
odil (0.10.0-9) unstable; urgency=medium

  * Team upload.
  * debian patch enable_nose_args.patch allows arguments to be
    provided to the nosetests executable. Used to specify the python
    version running nose. Closes: #943473.

 -- Drew Parsons <dparsons@debian.org>  Sat, 16 Nov 2019 04:44:54 +0800

odil (0.10.0-8) unstable; urgency=medium

  * Team upload.
  * Build-Depends: python3-all-dev. Make tests work with all supported
    python3 versions (3.7, 3.8). Closes: #943473.

 -- Drew Parsons <dparsons@debian.org>  Fri, 15 Nov 2019 21:13:37 +0800

odil (0.10.0-7) unstable; urgency=medium

  * Team upload.
  * must specify nosetests3 to run tests with python3

 -- Drew Parsons <dparsons@debian.org>  Wed, 04 Sep 2019 15:59:22 +0800

odil (0.10.0-6) unstable; urgency=medium

  * Team upload.
  * nopy tests also need python3 to run

 -- Drew Parsons <dparsons@debian.org>  Wed, 04 Sep 2019 11:36:03 +0800

odil (0.10.0-5) unstable; urgency=medium

  * Team upload.
  * run tests using the Python version being tested

 -- Drew Parsons <dparsons@debian.org>  Wed, 04 Sep 2019 09:35:41 +0800

odil (0.10.0-4) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.4.0
  * Set debhelper with Build-Depends: debhelper-compat (= 12)
  * Remove python-odil package (Python2 removal). Closes: #937183.

 -- Drew Parsons <dparsons@debian.org>  Wed, 04 Sep 2019 02:30:24 +0800

odil (0.10.0-3) unstable; urgency=medium

  [ Julien Lamy ]
  * Fix building with dcmtk 3.6.4-1

  [ Andreas Tille ]
  * Standards-Version: 4.3.0
  * debhelper 12
  * override_dh_dwz

 -- Julien Lamy <lamy@unistra.fr>  Mon, 14 Jan 2019 18:42:21 +0100

odil (0.10.0-2) unstable; urgency=medium

  * Team Upload

  [ Matthias Klose ]
  * Fix typo in build target, make the build a little bit more verbose.
    Closes: #915396

  [ Andreas Tille ]
  * debhelper 11
  * Testsuite: autopkgtest-pkg-python
  * Secure URI in copyright format
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target
  * Remove trailing whitespace in debian/control
  * Remove trailing whitespace in debian/copyright
  * Remove trailing whitespace in debian/rules

 -- Andreas Tille <tille@debian.org>  Mon, 03 Dec 2018 15:59:16 +0100

odil (0.10.0-1) unstable; urgency=medium

  * New upstream release (Closes: #914144)
  * Update copyright
  * Update standards version
  * Clean-up d/rules and d/control

 -- Julien Lamy <lamy@unistra.fr>  Tue, 27 Nov 2018 12:37:31 +0200

=== debian/control ===
Source: odil
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Julien Lamy <lamy@unistra.fr>
Section: science
Testsuite: autopkgtest-pkg-python
Priority: optional
Build-Depends: debhelper-compat (= 12),
               d-shlibs (>= 0.81),
               dh-python,
               cmake,
               g++ (>= 4:7),
               pkg-config,
               libjsoncpp-dev,
               libdcmtk-dev | libdcmtk2-dev,
               libicu-dev,
               zlib1g-dev,
               uuid-dev,
               libboost-dev,
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-log-dev,
               libboost-python-dev,
               pybind11-dev,
               python3-pybind11,
               libboost-test-dev,
               chrpath,
               dcmtk,
               python3-all-dev,
               python3-nose
Build-Depends-Indep: doxygen,
                     graphviz
Standards-Version: 4.4.0
Vcs-Browser: https://salsa.debian.org/med-team/odil
Vcs-Git: https://salsa.debian.org/med-team/odil.git
Homepage: https://github.com/lamyj/odil

Package: libodil0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: libdcmtkpp0
Provides: libdcmtkpp0
Replaces: libdcmtkpp0
Description: C++11 library for the DICOM standard
 Odil leverages C++ constructs to provide a user-friendly API of the
 different parts of the DICOM standard. Included in Odil are exception-based
 error handling, generic access to datasets elements, standard JSON and XML
 representation of datasets, and generic implementation of messages, clients
 and servers for the various DICOM protocols.
 .
 Odil also provides conversion to and from DCMTK data structures.
 .
 This package contains the shared library.

Package: libodil-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libodil0 (= ${binary:Version}),
         ${devlibs:Depends},
         ${misc:Depends}
Conflicts: libodil0-dev,
           libdcmtkpp-dev
Provides: libodil0-dev,
          libdcmtkpp-dev
Replaces: libodil0-dev,
          libdcmtkpp-dev
Description: C++11 library for the DICOM standard (development files)
 Odil leverages C++ constructs to provide a user-friendly API of the
 different parts of the DICOM standard. Included in Odil are exception-based
 error handling, generic access to datasets elements, standard JSON and XML
 representation of datasets, and generic implementation of messages, clients
 and servers for the various DICOM protocols.
 .
 This package contains the development files.

Package: libodil-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-jquery,
         ${misc:Depends}
Conflicts: libodil0-doc,
           libdcmtkpp0-doc
Provides: libodil0-doc,
          libdcmtkpp0-doc
Replaces: libodil0-doc,
          libdcmtkpp0-doc
Description: C++11 library for the DICOM standard (documentation)
 Odil leverages C++ constructs to provide a user-friendly API of the
 different parts of the DICOM standard. Included in Odil are exception-based
 error handling, generic access to datasets elements, standard JSON and XML
 representation of datasets, and generic implementation of messages, clients
 and servers for the various DICOM protocols.
 .
 This package contains the documentation files.

Package: python3-odil
Architecture: any
Multi-Arch: foreign
Section: python
Depends: libodil0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends}
Description: C++11 library for the DICOM standard (Python 3 wrappers)
 Odil leverages C++ constructs to provide a user-friendly API of the
 different parts of the DICOM standard. Included in Odil are exception-based
 error handling, generic access to datasets elements, standard JSON and XML
 representation of datasets, and generic implementation of messages, clients
 and servers for the various DICOM protocols.
 .
 This package contains the Python 3 wrappers.

Package: odil
Architecture: all
Depends: python3-odil,
         ${python3:Depends},
         ${misc:Depends}
Description: C++11 library for the DICOM standard (application)
 Odil leverages C++ constructs to provide a user-friendly API of the
 different parts of the DICOM standard. Included in Odil are exception-based
 error handling, generic access to datasets elements, standard JSON and XML
 representation of datasets, and generic implementation of messages, clients
 and servers for the various DICOM protocols.
 .
 This package contains the command-line application.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# needed for the tests
export DCMDICTPATH=$(shell ls /usr/share/libdcmtk*/dicom.dic | head -n 1)

# Find all Python versions
PYTHON3=$(shell py3versions -vd)
ALLPY=$(shell py3versions -vs)

%:
	dh $@ --builddirectory=build --with python3

# Base build: no wrappers
override_dh_auto_configure-arch:
	dh_auto_configure -- \
	  -DBUILD_EXAMPLES=OFF \
	  -DBUILD_PYTHON_WRAPPERS=OFF -DBUILD_JAVASCRIPT_WRAPPERS=OFF

override_dh_auto_build-nopy:
	dh_auto_build
	mv build build-nopy

# Reconfigure base build for specific Python version and build wrappers
# WARNING: Python2 and Python3 MUST be built sequentially since they use the
# same build directory
override_dh_auto_build-py: override_dh_auto_build-nopy
	set -e; \
	for Python in $(ALLPY); do \
	  echo "=== Building for Python $${Python} ==="; \
	  cp -a build-nopy build; \
	  dh_auto_configure -- \
	    -DBUILD_EXAMPLES=OFF \
	    -DBUILD_PYTHON_WRAPPERS=ON -DBUILD_JAVASCRIPT_WRAPPERS=OFF \
	    -DPYTHON_EXECUTABLE=/usr/bin/python$${Python}; \
	  dh_auto_build; \
	  mv build build-py$${Python}; \
	done

override_dh_auto_build-arch: override_dh_auto_build-nopy override_dh_auto_build-py

override_dh_auto_build-indep:
	dh_auto_configure --builddirectory=build-indep -- \
	  -DBUILD_EXAMPLES=OFF \
	  -DBUILD_PYTHON_WRAPPERS=ON -DBUILD_JAVASCRIPT_WRAPPERS=OFF \
	  -DPYTHON_EXECUTABLE=/usr/bin/python$(PYTHON3)
	mkdir -p documentation/_build
	cd documentation && doxygen
	find documentation/_build -name "*.md5" -delete

# Run C++ tests only on base build
override_dh_auto_test-arch-nopy:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	ln -s build-nopy build
	cd build && python3 ../tests/run --no-network --nose nosetests3 -e ".*"
	rm build
endif

# Run Python tests only on python build
# WARNING: Python2 and Python3 MUST be tested sequentially since they use the
# same build directory
override_dh_auto_test-arch-py: override_dh_auto_test-arch-nopy
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	set -e; \
	for Python in $(ALLPY); do \
	  echo "=== Testing for Python $${Python} ==="; \
	  ln -s build-py$${Python} build; \
	  ln -sr ./build/wrappers/python ./build/odil; \
	  ln -sr ./wrappers/python/*.py ./build/odil; \
	  cd build && \
	    python$${Python} ../tests/run --no-network \
	      --nose python$${Python} --noseargs "-m nose" \
	      -E ".*"; \
	  cd ..; \
	  rm ./build/odil/*py; \
	  rm ./build/odil; \
	  rm build; \
	done
endif

override_dh_auto_test-arch: override_dh_auto_test-arch-nopy override_dh_auto_test-arch-py

override_dh_auto_install-arch-nopy:
	ln -s build-nopy build
	$(MAKE) -C build/src install DESTDIR=$(CURDIR)/debian/tmp
	rm build

# WARNING: Python2 and Python3 MUST be installed sequentially since they use the
# same build directory
override_dh_auto_install-arch-py: override_dh_auto_install-arch-nopy
	set -e; \
	for Python in $(ALLPY); do \
	  echo "=== Installing for Python $${Python} ==="; \
	  ln -s build-py$${Python} build; \
	  $(MAKE) -C build/wrappers/python install DESTDIR=$(CURDIR)/debian/tmp; \
	  rm build; \
	done

override_dh_auto_install-arch: override_dh_auto_install-arch-nopy override_dh_auto_install-arch-py

override_dh_auto_install-indep:
	ln -s build-indep build
	$(MAKE) -C build/applications install DESTDIR=$(CURDIR)/debian/tmp
	rm build

override_dh_install-arch:
	dh_install
	d-shlibmove \
		--devunversioned \
		--commit --multiarch --exclude-a --exclude-la \
		--movedev debian/tmp/usr/include/* usr/include \
		--override s/libboost_log.*-dev/libboost-log-dev/ \
		debian/tmp/usr/lib/*.so

override_dh_clean:
	dh_clean
	find tests -name "*pyc" -delete
	rm -rf build-nopy $(ALLPY:%=build-py%) build-indep documentation/_build

# These steps are not needed for arch-independent packages
override_dh_auto_configure-indep:
override_dh_auto_test-indep:

## odil 0.11.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,12 @@
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 3.5)
 
 project("odil")
-set(odil_MAJOR_VERSION 0)
-set(odil_MINOR_VERSION 10)
-set(odil_PATCH_VERSION 0)
-set(odil_VERSION
-    ${odil_MAJOR_VERSION}.${odil_MINOR_VERSION}.${odil_PATCH_VERSION})
+
+set(odil_VERSION 0.11.0)
+string(REGEX MATCH "^([0-9]+)\\.([0-9]+)\\.([0-9]+)" _ "${odil_VERSION}")
+set(odil_MAJOR_VERSION "${CMAKE_MATCH_1}")
+set(odil_MINOR_VERSION "${CMAKE_MATCH_2}")
+set(odil_PATCH_VERSION "${CMAKE_MATCH_3}")
 
 option(BUILD_SHARED_LIBS "Build Odil with shared libraries." ON)
 option(BUILD_EXAMPLES "Build the examples directory." ON)
@@ -48,6 +49,11 @@
     else() # Windows XP (5.1)
         add_definitions(-D _WIN32_WINNT=0x0501)
     endif()
+    
+    # Starting with Visual Studio 2015 / VC 14 / MSVC 19.00, snprintf is present
+    if(${MSVC_VERSION} GREATER_EQUAL "1900")
+        add_definitions(-D HAVE_SNPRINTF)
+    endif()
 endif()
 
 add_subdirectory("src")

=== applications/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 if(BUILD_PYTHON_WRAPPERS)
     execute_process(
         COMMAND ${PYTHON_EXECUTABLE}
-          -c "from distutils.sysconfig import *; print(get_python_lib(True, prefix=''))"
+          -c "from distutils.sysconfig import *; print(get_python_lib(True, prefix='').replace('\\\\', '/'))"
         OUTPUT_VARIABLE PYTHON_SITE_PACKAGES
         OUTPUT_STRIP_TRAILING_WHITESPACE)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-find_package(Boost REQUIRED COMPONENTS date_time filesystem log system)
+find_package(Boost REQUIRED COMPONENTS date_time exception filesystem log system)
 find_package(ICU REQUIRED)
 find_package(JsonCpp REQUIRED)
 if(WITH_DCMTK)
@@ -32,6 +32,9 @@
     -D BOOST_ASIO_SEPARATE_COMPILATION
     -D ODIL_MAJOR_VERSION=${odil_MAJOR_VERSION}
 )
+if(WIN32)
+    add_definitions(-D BOOST_UUID_FORCE_AUTO_LINK)
+endif()
 if(BUILD_SHARED_LIBS)
     add_definitions(-D BOOST_ALL_DYN_LINK)
 endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -46,8 +46,13 @@
     endif()
 
     add_executable(test_${test} ${test_file} ${headers} ${extra_files})
+    
     target_link_libraries(
         test_${test} libodil ${Boost_LIBRARIES} ${DCMTK_LIBRARIES})
+    if(WIN32)
+        target_link_libraries(test_${test} Ws2_32)
+    endif()
+    
     set_target_properties(test_${test} PROPERTIES OUTPUT_NAME ${test} FOLDER "Tests")
 
     file(READ ${test_file} content)

=== examples/cpp/CMakeLists.txt ===
find_package(Boost REQUIRED)
find_package(DCMTK REQUIRED)
find_package(JsonCpp REQUIRED)

include_directories(
    ${CMAKE_SOURCE_DIR}/src ${Boost_INCLUDE_DIRS} ${DCMTK_INCLUDE_DIRS}
    ${JsonCpp_INCLUDE_DIRS})

add_definitions(
    ${DCMTK_DEFINITIONS}
    -D ODIL_MAJOR_VERSION=${odil_MAJOR_VERSION}
)
if(BUILD_SHARED_LIBS)
    add_definitions(-D BOOST_ALL_DYN_LINK)
endif()

link_directories(${Boost_LIBRARY_DIRS} ${DCMTK_LIBRARY_DIRS})

file(GLOB_RECURSE examples *.cpp)

foreach(example_file ${examples})
    get_filename_component(example ${example_file} NAME_WE)
    add_executable(${example} ${example_file})
    target_link_libraries(${example} libodil)
    if(INSTALL_EXAMPLES)
        install(TARGETS ${example} RUNTIME DESTINATION bin)
    endif()
    set_target_properties(${example} PROPERTIES FOLDER "Examples")
endforeach()

=== wrappers/js/CMakeLists.txt ===
find_package(Boost REQUIRED COMPONENTS system)

if(NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common")
    file(
        DOWNLOAD http://download.icu-project.org/files/icu4c/58.2/icu4c-58_2-src.zip
        ${CMAKE_CURRENT_BINARY_DIR}/icu4c-58_2-src.zip SHOW_PROGRESS)
    execute_process(
        COMMAND ${CMAKE_COMMAND} -E tar x icu4c-58_2-src.zip
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
endif()

if(NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/jsoncpp-1.8.0/dist/jsoncpp.cpp")
    file(
        DOWNLOAD https://github.com/open-source-parsers/jsoncpp/archive/1.8.0.zip 
        ${CMAKE_CURRENT_BINARY_DIR}/jsoncpp-1.8.0.zip SHOW_PROGRESS)
    execute_process(
        COMMAND ${CMAKE_COMMAND} -E tar x jsoncpp-1.8.0.zip
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    execute_process(
        COMMAND python amalgamate.py 
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/jsoncpp-1.8.0)
endif()

if (NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/boost")
    execute_process( COMMAND ln -s ${Boost_INCLUDE_DIRS}/boost ${CMAKE_CURRENT_BINARY_DIR})
endif()

set(icu_files
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/bytestream.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/charstr.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/cmemory.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/putil.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/stringpiece.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucln_cmn.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucmndata.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv2022.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnvbocu.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnvhz.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnvisci.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnvlat1.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnvmbcs.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnvscsu.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_bld.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_cb.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_ct.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_cnv.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_err.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_ext.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_io.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_lmb.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_u7.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_u8.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_u16.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ucnv_u32.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/udata.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/udatamem.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/uhash.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/uinvchar.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/umapfile.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/umath.c"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/umutex.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/unistr.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/unistr_cnv.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/uobject.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ustr_cnv.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ustring.cpp"
    "${CMAKE_CURRENT_BINARY_DIR}/icu/source/common/ustrtrns.cpp")

set(json_cpp_files 
    "${CMAKE_CURRENT_BINARY_DIR}/jsoncpp-1.8.0/dist/jsoncpp.cpp")

set(odil_files 
    "${CMAKE_SOURCE_DIR}/src/odil/base64.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/DataSet.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/Element.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/ElementsDictionary.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/Exception.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/json_converter.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/Reader.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/registry.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/Tag.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/uid.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/UIDsDictionary.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/unicode.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/Value.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/VR.cpp" 
    "${CMAKE_SOURCE_DIR}/src/odil/VRFinder.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/HTTPRequest.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/HTTPResponse.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/ItemWithParameters.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/Message.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/multipart_related.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/QIDORSRequest.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/QIDORSResponse.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/Selector.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/URL.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/WADORSRequest.cpp"
    "${CMAKE_SOURCE_DIR}/src/odil/webservices/WADORSResponse.cpp")

file(GLOB_RECURSE files "*cpp") 

set(CMAKE_C_COMPILER emcc)
set(CMAKE_CXX_COMPILER em++)
set(CMAKE_AR emar)
set(CMAKE_RANLIB emranlib)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --bind -s ALLOW_MEMORY_GROWTH=1 -s DISABLE_EXCEPTION_CATCHING=0")

set(CMAKE_C_CREATE_STATIC_LIBRARY "<CMAKE_AR> rc <TARGET> <LINK_FLAGS> <OBJECTS>")
set(CMAKE_CXX_CREATE_STATIC_LIBRARY "<CMAKE_AR> rc <TARGET> <LINK_FLAGS> <OBJECTS>")

add_definitions(
    -D ODIL_MAJOR_VERSION=${odil_MAJOR_VERSION}
    -D U_COMMON_IMPLEMENTATION -D U_DISABLE_RENAMING=1
)

include_directories(
    ${Boost_INCLUDE_DIRS}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}/icu/source/common
    ${CMAKE_CURRENT_BINARY_DIR}/jsoncpp-1.8.0/dist/
    ${CMAKE_SOURCE_DIR}/src)

add_executable(odil_js ${icu_files} ${json_cpp_files} ${odil_files} ${files})

set_target_properties(odil_js PROPERTIES OUTPUT_NAME odil)
set_target_properties(odil_js PROPERTIES SUFFIX ".js")

=== wrappers/python/CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
     set_target_properties(pyodil PROPERTIES SUFFIX ".so")
 endif()
 
-target_link_libraries(pyodil ${JsonCpp_LIBRARIES} libodil)
+target_link_libraries(pyodil PUBLIC ${JsonCpp_LIBRARIES} PUBLIC libodil)
 
 add_custom_target(
     pyodil-pure ${CMAKE_COMMAND} -E echo "Pure-python files"
@@ -34,7 +34,7 @@
 
 execute_process(
     COMMAND ${PYTHON_EXECUTABLE}
-      -c "from distutils.sysconfig import *; print(get_python_lib(True, prefix=''))"
+      -c "from distutils.sysconfig import *; print(get_python_lib(True, prefix='').replace('\\\\', '/'))"
     OUTPUT_VARIABLE PYTHON_SITE_PACKAGES
     OUTPUT_STRIP_TRAILING_WHITESPACE)

=== debian/changelog ===
odil (0.11.0-1build1) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:34:40 +0100

odil (0.11.0-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version: 4.5.0
  * Update copyright

 -- Julien Lamy <lamy@unistra.fr>  Mon, 17 Feb 2020 19:41:40 +0100

=== debian/control ===
--- 
+++ 
@@ -25,11 +25,10 @@
                libboost-test-dev,
                chrpath,
                dcmtk,
-               python3-all-dev,
-               python3-nose
+               python3-all-dev
 Build-Depends-Indep: doxygen,
                      graphviz
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/odil
 Vcs-Git: https://salsa.debian.org/med-team/odil.git
 Homepage: https://github.com/lamyj/odil

=== debian/rules ===
--- 
+++ 
@@ -23,7 +23,7 @@
 	mv build build-nopy
 
 # Reconfigure base build for specific Python version and build wrappers
-# WARNING: Python2 and Python3 MUST be built sequentially since they use the
+# WARNING: builds for Python versions MUST be sequential since they use the
 # same build directory
 override_dh_auto_build-py: override_dh_auto_build-nopy
 	set -e; \
@@ -49,18 +49,9 @@
 	cd documentation && doxygen
 	find documentation/_build -name "*.md5" -delete
 
-# Run C++ tests only on base build
-override_dh_auto_test-arch-nopy:
-ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	ln -s build-nopy build
-	cd build && python3 ../tests/run --no-network --nose nosetests3 -e ".*"
-	rm build
-endif
-
-# Run Python tests only on python build
-# WARNING: Python2 and Python3 MUST be tested sequentially since they use the
+# WARNING: tests for Python versions MUST be sequential since they use the
 # same build directory
-override_dh_auto_test-arch-py: override_dh_auto_test-arch-nopy
+override_dh_auto_test-arch:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	set -e; \
 	for Python in $(ALLPY); do \
@@ -69,24 +60,22 @@
 	  ln -sr ./build/wrappers/python ./build/odil; \
 	  ln -sr ./wrappers/python/*.py ./build/odil; \
 	  cd build && \
-	    python$${Python} ../tests/run --no-network \
-	      --nose python$${Python} --noseargs "-m nose" \
-	      -E ".*"; \
+	    $(MAKE) install DESTDIR=../install && \
+	    WORKSPACE=$(CURDIR) ../.ci/deb/post_build || true;\
 	  cd ..; \
 	  rm ./build/odil/*py; \
 	  rm ./build/odil; \
 	  rm build; \
+	  rm -rf install; \
 	done
 endif
-
-override_dh_auto_test-arch: override_dh_auto_test-arch-nopy override_dh_auto_test-arch-py
 
 override_dh_auto_install-arch-nopy:
 	ln -s build-nopy build
 	$(MAKE) -C build/src install DESTDIR=$(CURDIR)/debian/tmp
 	rm build
 
-# WARNING: Python2 and Python3 MUST be installed sequentially since they use the
+# WARNING: installs for Python versions MUST be sequential since they use the
 # same build directory
 override_dh_auto_install-arch-py: override_dh_auto_install-arch-nopy
 	set -e; \
@@ -117,6 +106,7 @@
 	dh_clean
 	find tests -name "*pyc" -delete
 	rm -rf build-nopy $(ALLPY:%=build-py%) build-indep documentation/_build
+	rm -f build
 
 # These steps are not needed for arch-independent packages
 override_dh_auto_configure-indep:
